/*
 * JLabelAntialias.java
 *
 * Creado el 9 de marzo de 2006, 11:37
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package com.mhpsc.antialias;

import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridLayout;
import java.awt.RenderingHints;
import java.util.Enumeration;
import java.util.Properties;
import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 *
 * @author avelino
 */
public class JLabelAntialias extends JLabel {
    
    public JLabelAntialias(String text) {
        super(text);
    }

    public void paint(Graphics g) {
        Graphics2D g2d = (Graphics2D) g;
        g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        super.paint(g);
    }
    
    public static void showProperties() {
        Properties p = System.getProperties();
        Enumeration e = p.keys();
        while (e.hasMoreElements()) {
            Object key = e.nextElement();
            Object value = p.get(key);
            System.out.println("'" + key.toString() + "' = '" + value.toString() + "'");
        }
    }
    
    public static void main(String[] args) {
        JFrame frame = new JFrame();
        frame.getContentPane().setLayout(new GridLayout(2, 1));
        JLabel e1 = new JLabel("HOLA 0123456789");
        e1.setFont(new Font("Dialog", 1, 12));
        frame.getContentPane().add(e1);
        JLabel e2 = new JLabelAntialias("HOLA 0123456789");
        e2.setFont(new Font("Dialog", 1, 12));
        frame.getContentPane().add(e2);
        frame.pack();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.show();
        showProperties();
    }
}
