/*
 * JComboBoxButton.java
 *
 * Creado el 21 de abril de 2006, 13:47
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package com.mhpsc.combos;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.ComboBoxEditor;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;

/**
 *
 * @author avelino
 */
public class JComboBoxButton extends JComboBox implements ComboBoxEditor {
    private JButton b = new JButton();
    private Object item = null;
    private ArrayList actionListeners = new ArrayList();
    
    public JComboBoxButton() {
        super.setEditor(this);
        this.setEditable(true);
    }

    public void setEditor(ComboBoxEditor e) {
    }
    
    public Component getEditorComponent() {
        return this.b;
    }

    public void setItem(Object anObject) {
        this.item = anObject;
        if (anObject != null)
            this.b.setText(anObject.toString());
        else
            this.b.setText("(vaco)");
    }

    public Object getItem() {
        return this.item;
    }

    public void selectAll() {
        this.b.requestFocus();
    }

    public void addButtonActionListener(ActionListener l) {
        this.b.addActionListener(l);
    }

    public void removeButtonActionListener(ActionListener l) {
        this.b.removeActionListener(l);
    }

    public static void main(String[] args) {
        JFrame f = new JFrame("Ejemplo");
        f.getContentPane().setLayout(null);
        JComboBoxButton c = new JComboBoxButton();
        c.addItem("avelino");
        c.addItem("jos");
        c.addItem("marcos");
        c.setBounds(10, 10, 200, 20);
        c.addButtonActionListener(
                new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        System.out.println("Botn");
                    }
                }
        );
        f.getContentPane().add(c);
        f.setSize(400, 300);
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.show();
    }
}
