/*
 * JTableHeaderClickable.java
 *
 * Creado el 5 de abril de 2006, 15:54
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package com.mhpsc.tablas;

import java.awt.GridLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;

/**
 *
 * @author avelino
 */
public class JTableHeaderClickable extends JTableHeader implements MouseListener {
    protected OrderableTableModel orderableTableModel = null;
    
    public JTableHeaderClickable() {
        super();
        this.addMouseListener(this);
    }
    
    public JTableHeaderClickable(TableColumnModel cm) {
        super(cm);
        this.addMouseListener(this);
    }
    
    public JTableHeaderClickable(JTable table) {
        super(table.getColumnModel());
        this.addMouseListener(this);
        table.setTableHeader(this);
        TableModel model = table.getModel();
        if (model instanceof OrderableTableModel)
            this.orderableTableModel = (OrderableTableModel) model;
    }

    // MouseListener
    public void mouseClicked(MouseEvent e) {
        int column = this.columnAtPoint(e.getPoint());
        //System.out.println("click (column = " + column + ")");
        if ((this.orderableTableModel != null) && (column >= 0)) {
            boolean direct = this.orderableTableModel.isDirectOrder(column);
            this.orderableTableModel.setOrder(column, !direct);
        }
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }
    // -------------
    
    public static void main(String[] args) {
        JFrame frame = new JFrame("ejemplo tabla");
        frame.getContentPane().setLayout(new GridLayout(1, 1));
        JScrollPane scroll = new JScrollPane();

        JTable table = new JTable();
        TableModel model = new NumberTableModelOrderable();
        table.setModel(model);
        new JTableHeaderClickable(table);
        
        scroll.setViewportView(table);
        frame.getContentPane().add(scroll);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.show();
    }
}
