/*
 * NumberTableModelOrderable.java
 *
 * Creado el 5 de abril de 2006, 16:23
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package com.mhpsc.tablas;

import java.util.Arrays;
import java.util.Comparator;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

/**
 *
 * @author avelino
 */
public class NumberTableModelOrderable extends DefaultTableModel implements OrderableTableModel, TableModel, Comparator {
    protected int[][] values = new int[][]{new int[]{100, 2, 8, 44}, new int[]{5, 60, 7, 8}, new int[]{90, 10, 11, 12}};
    protected String[] columnNames = new String[]{"a", "b", "c", "d"};
    protected int orderColumn = -1;
    protected boolean directOrder = false;

    public NumberTableModelOrderable() {
        super();
    }

    // OrderableTableModel
    public boolean isDirectOrder(int column) {
        if (this.orderColumn == column)
            return this.directOrder;
        else
            return false;
    }

    public void setOrder(int column, boolean direct) {
        this.orderColumn = column;
        this.directOrder = direct;
        Arrays.sort(this.values, this);
        this.fireTableDataChanged();
    }
    // -------------------

    // TableModel
    public int getRowCount() {
        return 3;
    }

    public int getColumnCount() {
        return 4;
    }

    public String getColumnName(int columnIndex) {
        return this.columnNames[columnIndex];
    }

    public Class getColumnClass(int columnIndex) {
        return Integer.class;
    }

    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return false;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        return new Integer(this.values[rowIndex][columnIndex]);
    }

    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
    }
    // ----------

    // Comparator
    public int compare(Object o1, Object o2) {
        int[] a1 = (int[]) o1;
        int[] a2 = (int[]) o2;
        int v1 = a1[this.orderColumn];
        int v2 = a2[this.orderColumn];
        if (this.directOrder)
            return v1 - v2;
        else
            return v2 - v1;
    }
    // ----------

}
